module GList (GList(gmap,gzero,gcat,gfilter,gsequence),MonadPlus(mzero,mplus),
              Functor(fmap),gconcat,gconcat',gmapM) where
import Monad

class (Functor l, MonadPlus l) => GList l where
   gmap :: (a -> b) -> (l a -> l b)
   gmap = fmap
 
   gzero :: l a
   gzero = mzero

   gcat :: l a -> l a -> l a
   gcat = mplus
   gfilter :: (a -> Bool) -> l a -> l a

   gsequence :: Monad m => l (m a) -> m (l a)

   -- the following are defined here to allow for overriding with a more
   -- efficient implementation
   gconcat :: l (l a) -> l a
   gconcat = join

   gconcat' :: [l a] -> l a
   gconcat' = msum

   gmapM :: Monad m => (a -> m b) -> (l a -> m (l b))
   gmapM f = gsequence . gmap f   

instance GList [] where
   gfilter = filter
   gsequence = sequence

